/////////////////////////////////
//  delay.c C18pfB[֐  //
//  2008/01/15                 //
/////////////////////////////////

#include "global.h"

#if (CONFIG_MHZ == 4)	//4MHz: max 2.5S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num <256) Delay1KTCYx(num);
	else if(num >= 256 && num < 2560){
		buff = num/10;
		Delay10KTCYx(buff);
	}
	else if(num >=2560) Delay10KTCYx(255);
}

#elif (CONFIG_MHZ == 8)	//8MHz: max 1.3S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num < 128){
		buff = num*2;
		Delay1KTCYx(buff);
	}
	else if(num >= 128 && num < 1280){
		buff = num/5;
		Delay10KTCYx(buff);
	}
	else if(num >= 1280) Delay10KTCYx(255);
}

#elif (CONFIG_MHZ == 10) //10MHz: max 1S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num < 103){
		buff = num*5/2;
		Delay1KTCYx(buff);
	}
	else if(num >= 103 && num < 1024){
		buff = num/4;
		Delay10KTCYx(buff);
	}
	else if(num >= 1024) Delay10KTCYx(255);
}

#elif (CONFIG_MHZ == 16) //16MHz: max 0,63S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num < 64){
		buff = num*4;
		Delay1KTCYx(buff);
	}
	else if(num >= 64 && num < 640){
		buff = num*2/5;
		Delay10KTCYx(buff);
	}
	else if(num >= 640) Delay10KTCYx(255);
}

#elif (CONFIG_MHZ == 20) //20MHz: max 0.5S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num < 52){
		buff = num*5;
		Delay1KTCYx(buff);
	}
	else if(num >= 52 && num < 512){
		buff = num/2;
		Delay10KTCYx(buff);
	}
	else if(num >= 512) Delay10KTCYx(255);
}

#elif (CONFIG_MHZ == 24) //24MHz: max 0.43S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num < 43){
		buff = num*6;
		Delay1KTCYx(buff);
	}
	else if(num >= 43 && num < 426){
		buff = num*3/5;
		Delay10KTCYx(buff);
	}
	else if(num >= 426) Delay10KTCYx(255);
}

#elif (CONFIG_MHZ == 32) //32MHz: max 0.32S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num < 32){
		buff = num*8;
		Delay1KTCYx(buff);
	}
	else if(num >= 32 && num < 320){
		buff = num*4/5;
		Delay10KTCYx(buff);
	}
	else if(num >= 320) Delay10KTCYx(255);
}

#elif (CONFIG_MHZ == 40) //40MHz: max 0.25S
void delay_ms(uint num){
	if(num > 0 && num < 256) Delay10KTCYx(num);
	else if(num >= 256) Delay10KTCYx(255);
}

#elif (CONFIG_MHZ == 48) //48MHz: max 0.2S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num < 22){
		buff = num*12;
		Delay1KTCYx(buff);
	}
	else if(num >= 22 && num < 214){
		buff = num*6/5;
		Delay10KTCYx(buff);
	}
	else if(num >= 214) Delay10KTCYx(255);
}

#else 	//8MHz: max 1.3S
void delay_ms(uint num){
	uint buff;
	if(num > 0 && num < 128){
		buff = num*2;
		Delay1KTCYx(buff);
	}
	else if(num >= 128 && num < 1280){
		buff = num/5;
		Delay10KTCYx(buff);
	}
	else if(num >= 1280) Delay10KTCYx(255);
}
#endif
