/////////////////////////////
//  global.h               //
//  2008/01/15             //
/////////////////////////////

#ifndef _GLOBAL_H
#define _GLOBAL_H

///// CPU Type
#include <p18f1320.h>

///// ^̒Zk
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

///// delay
#include <delays.h>
#define CONFIG_MHZ 8

extern void delay_ms( uint);

///// LCD
#define		lcd_port	LATB
#define		lcd_stb		LATBbits.LATB5
#define		lcd_rs		LATBbits.LATB4

extern void lcd_init(void);
extern void lcd_clear(void);
extern void lcd_cmd(char);
extern void lcd_data(char);
extern void lcd_str(char *);
extern void lcd_str_rom(rom const char *);

#endif