///////////////////////////////////////////////////////////
//  tCu[(SC1602,2004  4BIT BUS)	LCDLIB4L.C  //
//  w|[g̉4BITɐڑ邱   ibPWpj  //
///////////////////////////////////////////////////////////
#include "global.h"

//////////					P\
void lcd_data(char asci){								//asci: ݃f[^
	lcd_port = (asci >> 4 & 0x0f) | (lcd_port & 0xf0);	//f[^ʁi|[gʕۑj
	lcd_rs = 1;										//f[^̏
	Delay1TCY();										//NOP	
	lcd_stb = 1;										//Xg[uグ;
	Delay1TCY();										//NOP
	Delay1TCY();										//NOP
	lcd_stb = 0;										//Xg[u̗
	lcd_port = (asci & 0x0f) | (lcd_port & 0xf0);		//f[^ʁi|[gʕۑj
	lcd_stb = 1;										//Xg[uグ
	Delay1TCY();										//NOP
	Delay1TCY();										//NOP
	lcd_stb = 0;										//Xg[u̗
	Delay10TCYx(CONFIG_MHZ);							//40uS	
}
//////////					R}h̏
void lcd_cmd(char cmd){								//cmd: R}h
	lcd_port = (cmd >> 4 & 0x0f) | (lcd_port & 0xf0);		//f[^ʁi|[gʕۑj
	lcd_rs = 0;										//R}h̏
	Delay1TCY();										//NOP	
	lcd_stb = 1;										//Xg[uグ;
	Delay1TCY();										//NOP
	Delay1TCY();										//NOP
	lcd_stb = 0;										//Xg[u̗
	lcd_port = (cmd & 0x0f) | (lcd_port & 0xf0);			//f[^ʁi|[gʕۑj
	lcd_stb = 1;										//Xg[uグ
	Delay1TCY();										//NOP
	Delay1TCY();										//NOP
	lcd_stb = 0;										//Xg[u̗
	if((cmd & 0x3) !=0) delay_ms(2);
	else Delay10TCYx(CONFIG_MHZ);						//҂
}
/////// S֐
void lcd_clear(void)
{
	lcd_cmd(0x01);			//R}ho
}
/////// o͊֐iq`l̈j
void lcd_str(char *str)
{
	while(*str != 0x00)		//̏I蔻
	{
		lcd_data(*str);		//Po
		str++;				//|C^{P
	}
}
/////// o͊֐iqnl̈j
void lcd_str_rom(rom const char *stc)
{
	while(*stc != 0x00)		//̏I蔻
	{
		lcd_data(*stc);		//Po
		stc++;				//|C^{P
	}
}
/////////					R}h̏
void lcd_incmd(int cmd){								//cmd: R}h
	lcd_port = (cmd >> 4 & 0x0f) | (lcd_port & 0xf0);		// R}hi|[gʕۑj
	lcd_rs = 0;										// R}h̏
	lcd_stb = 1;										// Xg[uグ
	lcd_stb = 0;										// Xg[u̗
	delay_ms(5);
}
/////////					
void lcd_init(){
	delay_ms(15);
	lcd_incmd(0x30);		//8bit mode set
	lcd_incmd(0x30);		//8bit mode set
	lcd_incmd(0x30);		//8bit mode set
	lcd_incmd(0x20);		//4bit mode set
	lcd_cmd(0x28);		//DL=0 4bit mode,5x7dot
	lcd_cmd(0x0c);		//display on C=D=1 B=0
	lcd_cmd(0x06);		//entry I/D=1 S=0
	lcd_cmd(0x1);			//clear
}
